/**
 * Game of Life
 * 
 */
package gridlife.shape;



/**
 * Imports
 * 
 */
import gridlife.core.GridLifeConstants;
import java.io.File          ;
import java.io.FilenameFilter;



/**
 * Flat file extension filter for shapeset palette files
 * 
 * @author Ulf Wagemann
 */
public class GridLifeShapeSetFileFilter implements FilenameFilter
{
 /**
  * FilenameFilter.accept
  *
  * @param   lc_tFile  Directory (!)
  * @param   pa_sName  File name
  * @return  true, if we have a file ending with .pal, false otherwise
  */
 @Override
 public boolean accept(File pa_tFile, String pa_sName)
 {
  boolean lc_bResult = false;

  if (null != pa_sName)
  {
   if (true == pa_sName.toLowerCase().endsWith(GridLifeConstants.GOL_FILE_PALETTE_EXTENSION))
   {
     lc_bResult = true; 
   }
  }
  return lc_bResult;
 }  
}
