/*
 * Game of Life
 * 
 */
package gridlife.ui;



/**
 * Imports
 * 
 */
import javax.swing.text.PlainDocument;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;

import gridlife.core.GridLifeConstants;



/**
 * Document class for quick slot names. Validates just for letters and characters.
 * 
 * @author Ulf Wagemann
 */
public class GridLifeQuickSlotDocument extends PlainDocument
{
 /**
  * Adds content to the document. Allows just letters and digits and stuff to be entered.
   * 
  * @param pa_iOffset                 insert position
  * @param pa_sText                   text to be inserted
  * @param pa_tAttrSet                text attribute set
  * @throws BadLocationException      sucks, if it happens
  */
 @Override
 public void insertString(int pa_iOffset, String pa_sText, AttributeSet pa_tAttrSet) throws BadLocationException 
 {
  StringBuffer lc_tNewString = new StringBuffer();
  
  int  lc_iI    = 0;
  int  lc_iLen  = 0;
  char lc_tChar = 0;
  
  if (pa_sText != null && lc_tNewString != null) 
  {
   char[] lc_tChars = pa_sText.toCharArray();
   
   if (0 < (lc_iLen = lc_tChars.length))
   {
    for (lc_iI = 0; lc_iI < lc_iLen; lc_iI++) 
    {
     lc_tChar = lc_tChars[lc_iI];
     
     if (true == Character.isLetter(lc_tChar)                   || 
         true == Character.isDigit (lc_tChar)                   || 
         GridLifeConstants.GOL_QUICKSAVE_UNDERSCORE == lc_tChar ||
         GridLifeConstants.GOL_QUICKSAVE_HYPHEN     == lc_tChar  )
     {
      lc_tNewString.append(lc_tChar);
     }
    }
    super.insertString(pa_iOffset, lc_tNewString.toString(), pa_tAttrSet);
   }
  }
 }
}
